<template>
  <div class="root" v-show="showSelector">
    <BankSelectionDropdown :disabled="disabled" class="dropdown" @bank-selection="onBankSelection" />
    <AccountSelectionDropdown :disabled="disabled" :bank-id="currentBankSelection" @account-selection="onAccountSelection" />
  </div>
</template>

<script lang="ts">
import "reflect-metadata";
import { Component, Prop } from "vue-property-decorator";
import { mixins } from "vue-class-component";

import AccountSelectionDropdown from "@/components/bricks/AccountSelectionDropdown.vue";
import BankSelectionDropdown from "@/components/bricks/BankSelectionDropdown.vue";
import StoreModules from "@/mixins/StoreModules";
import { BASE_SELECT_NONEXISTENT_ID } from "@/constants/baseSelect";

@Component({
  components: {
    AccountSelectionDropdown,
    BankSelectionDropdown
  }
})
export default class BankAndAccountSelector extends mixins(StoreModules) {
  @Prop({ default: false }) public readonly disabled!: boolean;

  public currentBankSelection: number = BASE_SELECT_NONEXISTENT_ID;
  public currentAccountSelection: number = BASE_SELECT_NONEXISTENT_ID;

  public onBankSelection(selection: number) {
    this.currentBankSelection = selection;
    this.$emit("bank-selection", selection);
  }

  public onAccountSelection(selection: number) {
    this.currentAccountSelection = selection;
    this.$emit("account-selection", selection);
  }

  get showSelector() {
    return this.bankModule.allAccounts.size > 1;
  }
}
</script>


<style lang="scss" scoped>
.root {
    margin-bottom: 8px;
}

.dropdown {
    margin-bottom: 8px;
}
</style>
